__id__ = "$Id: command.py 378 2007-05-03 22:29:30Z theobald $"

from node import *

class CommandExecutor:
    def execute(self, node, trio_cursor):
        command = node.value[1:]
        executefn = getattr(self, 'execute_'+command, self.executeDefault)
        executefn(node, trio_cursor)

    def executeDefault(self, node, trio_cursor):
        raise Exception("Unsupported command: %s" % node.value)

    def execute_d(self, node, trio_cursor):
        cursor = trio_cursor.tdb.pdb.cursor()
        if isinstance(node.children[0], Empty):
            query = """select distinct tablename as table
                       from trio_tables where istemporary=FALSE"""
            cursor.execute(query)
        else:
            query = """select attrname from trio_attribs
                       where tablename = '%s'
                       order by colnum""" % node.children[0].value
            cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_c(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\l table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = """select distinct tablename as table
                   from trio_tables_lin
                   where srctable = '%s'""" % table
                   
        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_l(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\l table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = """select t.tablename
                   from trio_tables t, trio_tables_lin tl
                   where tl.tablename = '%s'
                   and t.tablename = tl.srctable""" % table

        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_t(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\t table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = """select type from trio_tables
                   where tablename = '%s'""" % table
                            
        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True
