__id__ = "$Id: createindex.py 567 2007-10-08 21:39:35Z theobald $"

def execute(node, trio_cursor):
    index = node.children[0].value
    name = node.children[1].value
    c_index = "trio_c_" + index + "_index"
    u_index = "trio_u_" + index + "_index"
    
    # Fetch uncertain columns
    u_columnnames = []
    cursor = trio_cursor.tdb.pdb.cursor()
    sql = "SELECT attrname FROM trio_attribs WHERE tablename = '%s' and iscertain=FALSE ORDER BY colnum ASC" % name
    cursor.execute(sql)
    cols = cursor.fetchall()
    for c in cols:
        u_columnnames.append(c[0])
            
    # Map certain and uncertain index columns
    c_cols = []
    u_cols = []
    for child in node.children[2].children:
        if child.value in u_columnnames:
            u_cols.append(child.value)
        else:
            c_cols.append(child.value)
    
    # Create indexes on data columns & X-ID
    if c_cols:
        cursor.execute("CREATE INDEX %s ON trio_c_%s (%s)" % (c_index, name, "trio_xid," + ",".join(c_cols)))
    if u_cols:
        cursor.execute("CREATE INDEX %s ON trio_u_%s (%s)" % (u_index, name, "trio_xid," + ",".join(u_cols)))
    print "INDEX CREATED"
    trio_cursor.tdb.commit();
