__id__ = "$Id: droptable.py 499 2007-06-04 20:17:27Z theobald $"

import common
from node import *

def execute(node, trio_cursor):
    trio_cursor.isFetchable = False
    c = trio_cursor.tdb.pdb.cursor()
    tables = [x.value for x in node.children[0].children]
    
    for table in tables:
        query = """select distinct trio_tables_lin.tablename 
                   from trio_tables_lin, trio_tables
                   where trio_tables_lin.tablename = trio_tables.tablename
                   and istemporary=false and srctable='%s'""" % table
        c.execute(query)
        
        # Recursively cascade over derived tables
        derived_tables = [tuple[0] for tuple in c.fetchall()]
        if isinstance(node.children[1], Cascade) and len(derived_tables) > 0:
            # Recursively drop all the derived tables.
            for child in derived_tables:
                if table != child:
                    trio_cursor.execute("drop table %s cascade" % child)
                # Remove the table from the list since the table has already been dropped
                if child in tables:
                    tables.remove(child)
        elif len(derived_tables) > 0:
            raise Exception("Cannot drop table that has derived tables")
        
        # Drop all entries related to this table
        exception = None
        try:
            c.execute("drop view %s" % table)
        except Exception,e:
            common.print_exception(e)
            trio_cursor.tdb.commit();
        try:
            c.execute("drop table trio_c_%s cascade" % table)
        except Exception,e:
            common.print_exception(e)
            trio_cursor.tdb.commit()
        try:
            c.execute("drop table trio_lin_%s" % table)
        except Exception, e:
            exception = e
            common.print_exception(e)
            trio_cursor.tdb.commit()
        try:
            c.execute("drop sequence trio_xid_%s" % table)
        except Exception, e:
            common.print_exception(e)
            trio_cursor.tdb.commit()
        try:
            query = "SELECT * FROM trio_tables WHERE tablename='%s' AND type in (0,2) AND istemporary=FALSE"
            c.execute(query % table)
            if c.fetchall():
                try:
                    c.execute("drop table trio_u_%s cascade" % table)
                except Exception,e:
                    common.print_exception(e)
                    trio_cursor.tdb.commit()
                try:
                    c.execute("drop sequence trio_aid_%s" % table)
                except Exception,e:
                    common.print_exception(e)
                    trio_cursor.tdb.commit()
            query = "SELECT * FROM trio_tables WHERE tablename='%s' AND istemporary=TRUE"
            c.execute(query % table)
            if c.fetchall():
                try:
                    c.execute("drop table %s" % table)
                except Exception, e:
                    common.print_exception(e)
                    trio_cursor.tdb.commit()
            c.execute("delete from trio_tables where tablename = '%s'" % table)
            c.execute("delete from trio_tables_lin where tablename = '%s'" % table)
            c.execute("delete from trio_attribs where tablename = '%s'" % table)
        except Exception, e:
            common.print_exception(e)
        trio_cursor.tdb.commit()
        if exception is not None:
            raise Exception("Table '%s' does not exist in Trio schema!" % table)
        
