import os
import sys
import pylons.config
import webhelpers
import getpass
import pgdb

from explorer.config.routing import make_map

def load_environment(global_conf={}, app_conf={}):
    map = make_map(global_conf, app_conf)
    # Setup our paths
    root_path = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
    paths = {'root_path': root_path,
             'controllers': os.path.join(root_path, 'controllers'),
             'templates': [os.path.join(root_path, path) for path in \
                           ('components', 'templates','public')],
             'static_files': os.path.join(root_path, 'public')
             }
    
    # The following options are passed directly into Myghty, so all configuration options
    # available to the Myghty handler are available for your use here
    myghty = {}
    myghty['log_errors'] = False
    myghty['escapes'] = dict(l=webhelpers.auto_link, s=webhelpers.simple_format)
    myghty['output_encoding'] = 'UTF-8'  
    
    # Add your own Myghty config options here, note that all config options will override
    # any Pylons config options
    
    # This is a Trio admin user login & password check
    if "prompt_password" in app_conf and app_conf["prompt_password"] == "true":
        try:
            if "default_user" in app_conf:
                db = pgdb.connect(database=app_conf["default_user"], user=app_conf["default_user"])
            else:
                db = pgdb.connect()
            db.close()
            print "\nPostgres DBA connection for TrioExplorer: OK\n"
        except Exception, e:
            if "does not exist" in str(e):
                print
                print e
                print "\nPostgres DBA connection required for TrioExplorer:"
                app_conf["username"] = raw_input("DBA username: ")
                app_conf["password"] = getpass.getpass("    password: ")
                print
                db = pgdb.connect(database=app_conf["username"], user=app_conf["username"], password=app_conf["password"])
                db.close()
            else:
                raise e
                
    # Return our loaded config object
    return pylons.config.Config(myghty, map, paths)
