<!--
This is the template file for displaying query results.

## $Id: select_result.tmpl 332 2006-10-11 17:11:48Z michi2 $ 
-->


<%python>
from common import TYPE_UNCERTAIN, TYPE_CONFIDENCE, TYPE_CERTAIN, TYPE_PROBABILISTIC
hasLineage = None
</%python>


<div class="box">
% if c.results.error is not None:

    <%doc>
    ##
    ## Query returned an error. Print the error message.
    ##
    </%doc>
    <div class="box_header">Query Result</div>
    <p><span class="error">ERROR</span>: <% c.results.error %></p>

% elif c.results.schema is None:

    <%doc>
    ##
    ## TODO: Right now there is no way of knowing what type of query
    ## got executed. Find a way to better support non-select queries. 
    ##
    </%doc>

    <div class="box_header">Query Result</div>
    <p><span class="success">SUCCESS</span>: TriQL command succeeded.</p>
% else:  # Show results

    <%doc>
    ##
    ## It looks like this is a result of a select query. Print the result. 
    ##
    </%doc>

    <%python>
    tupleIndex = c.results.getPage() * c.results.pageSize
    </%python>
    <div class="box_header">
    <div class="box_header_left">Query Result</div>
    <div class="box_header_right">
    
%    if len(c.results.results) > 0:
     <%doc>
     ##
     ## Print the range of tuples displayed. 
     ## e.g. "1 -  10  of 113 xtuple(s)"
     ##
    </%doc>
    <span class="bold">
    <% c.results.getPage() * c.results.pageSize + 1 %>
    </span> -
    <span class="bold">
    <% min(c.results.getNumResults(), (c.results.getPage() + 1) * c.results.pageSize) %>
    </span> of
%    # end ( range of tuple)

     <span class="bold"><% c.results.getNumResults() %></span> tuple(s)
     </div>
     <div class="spacer"></div>
     </div>
     <br />
     <p>


<%doc>
     ##
     ## Here comes the messy part. Display the query result. 
     ##
</%doc>
     <table class="results">

     <%doc>## Print out the header with attribute names. </%doc>
     <tr>

     <%doc>## An empty cell.</%doc>
     <th class="nontuple"></th>

##   Attribute names.
%    for k in range(len(c.results.schema)):
%      if k in c.results.u_columns:
         <th class="tuple<% c.results.type %>"><% c.results.schema[k][0].lower() %>*</th>
%      else:
         <th class="tuple<% c.results.type %>"><% c.results.schema[k][0].lower() %></th>
%
%    #end for

##   Question mark. 
     <th class="nontuple">
%    if (c.results.type == TYPE_CONFIDENCE or c.results.type == TYPE_PROBABILISTIC) and c.results.conf_computed == False:
        <%python>
        indexurl = "index?query=%s&compconf=True&page_num=%s" % (c.query, str(c.results.getPage()))
        </%python>
         <div class="conf-box<% c.results.type %>"><a href="<% indexurl %>">CONF-ALL</a></div>
%    #end if
     </th>
     </tr>


     <%python>
     num = len(c.results.schema) + 3
     </%python>
     <tr><td colspan="<% num %>" class="blank" height="8px"></td></tr>

     <%python>
     summary = []
     i = 0
     k = 0
     sequence = session['user'].sequence
     </%python>


%    for tuple in c.results.getResults():

         <%python>
         hidden_id = "hide" + str(sequence[0])
         sequence[0] = sequence[0] + 1
         shown_id = "show" + str(sequence[0])
         sequence[0] = sequence[0] + 1
         image_id = "image" + str(sequence[0])
         sequence[0] = sequence[0] + 1
         i = i + 1
         summary = []
         urls = []
         conf_ids = []
         image_ids = []
 
         ## Put an xtuple into a list of lists, where each list
         ## consists of value(s) of an attribute. 
         for attr in c.results.schema:
             summary.append([])
 
         for alt in tuple:
             for j in range(len(summary)):
                 val = alt[j]
                 if val is None:
                     val = "NULL"
                 if not str(val) in summary[j]:
                      summary[j].append(str(val))
         alts = ""
         </%python>

         <%doc>
         ##
         ## This part is hidden if there is more than one alternative. 
         ## It shows up when user clicks on the + button. 
         ##
         </%doc>
%        if len(tuple) > 1:
             <tbody id="<% hidden_id %>" class="hidden-rows" name="alt">
%        else:
             <tbody id="<% shown_id %>">
%        #end if

         <%python>
         tc = c.tcnx.cursor()
         altIndex = 0
         </%python>

%        for index in range(len(tuple)):
             <%python>
             alt = tuple[index]
             lin = alt.getLineage()
             </%python>
%            if hasLineage is None:
%                for table in lin.tables():
                     <%python>
                     tc.execute("\l %s" % table)
                     </%python>
%                    if tc.rowcount > 0:
                         <%python>
                         hasLineage = True
                         break
                         </%python>
%                    #end if
%                #end for
%                if hasLineage is None:
                      <%python>
                      hasLineage = False
                      </%python>
%                #end if
%            #end if
             <%python>
             aidlist = lin.aidstrs()
             lineage_id = "lineage" + str(sequence[0])
             sequence[0] = sequence[0] + 1
             image_id = "image" + str(sequence[0])
             sequence[0] = sequence[0] + 1
             aids2 = ",".join(aidlist)
             tables2 = ",".join(lin.tables())
             disj2 = ",".join(str(x) for x in lin.disjlin)
             </%python>
             <tr>
             <td class="nontuple">

%            if not c.results.nolineage and (not c.results.isViewTable or hasLineage):
             <%python>
             image_id = "image" + str(sequence[0])
             sequence[0] = sequence[0] + 1
             url = "lineage?tables=" + tables2 + "&aids=" + aids2 + "&disj=" + disj2
             if not c.results.isViewTable and not c.results.distinct:
                 url += "&top=t"
             </%python>
             <a href="javascript:xmlhttpPost('<% url %>', '<% lineage_id %>', '<% image_id %>')" 
             id="<% image_id %>"><img title="Show lineage of this alternative" 
             src="img/down.gif" alt="+" /></a>
%            #end if
              </td>
         
%            for k in range(len(alt)):
                <%python>
                aidlist = ",".join(map(str, alt.lineage.aids()))
                </%python>
%                if len(tuple) > 1:
                    <td class="alternative" onclick="toggle('<% hidden_id %>', '<% shown_id %>')" name="plusminus"
                     title="xid(s): <% str(tuple.xid).replace("_", ",") %>, aid(s): <% aidlist %>">
%                else:
                     <td class="nonclickable-alternative" title="xid(s): <% str(tuple.xid).replace("_", ",") %>, aid(s): <% aidlist %>">
%        

%		if alt[k] is not None:
%                   if k in c.results.u_columns:    #ternary expression:
                 <span class="uncertain"><% (alt[k]==' ') and '&nbsp;' or alt[k] %></span>
%                   else:    #ternary expression:
                 <b><% (alt[k]==' ') and '&nbsp;' or alt[k] %></b>
%
% 		else:
%                   if k in c.results.u_columns:
                 <span class="uncertain">NULL</span>
%                   else:
                    <b>NULL</b>
%
% 	        # end if

                 </td>
%            #end for 

         <td class="nontuple">

%            if c.results.type == TYPE_CONFIDENCE or c.results.type == TYPE_PROBABILISTIC:
%                if alt.getConfidence() == None:
<%python>
                     image_id = "image" + str(sequence[0])
                     sequence[0] = sequence[0] + 1
                     conf_id = "conf" + str(sequence[0])
                     sequence[0] = sequence[0] + 1
                     url = "confidence?table=" + tables2 + "&aid=" + aids2 + "&disj=" + disj2 + \
                     "&xindex=" + str(tupleIndex) + "&aindex=" + str(altIndex)
                     urls  += [url]
                     conf_ids += [conf_id]
                     image_ids += [image_id]
</%python>
                     <div class="conf-box<% c.results.type %>">
                     <a href="javascript:getConfidence('<% url %>', '<% conf_id %>', '<% image_id %>')" 
                     id="<% image_id %>" title="Get confidence of this alternative">conf</a>
                     <span id="<% conf_id %>"></span>
                     </div>
%                else:
                     <div class="conf-box<% c.results.type %>">
% if isinstance(alt.getConfidence(), float):
                     <% "%.3f" % alt.getConfidence() %>
% else:
                     <% alt.getConfidence() %>
%
                     </div>
%                #end if
%            elif c.results.type == TYPE_UNCERTAIN:
%                if tuple.getQuestionMark():
                      <div class="question-box">? </div>\
%                #end if 
%            #end if


         </td>
         </tr>


## The lineage of this alternative comes here.

             <tr class="lineage">
             <td class="lineage-noborder"></td>
             <td id="<% lineage_id %>" colspan="<% len(summary) %>"  class="lineage"></td>
             <td class="lineage-noborder"></td>
             </tr>
             <%python>
             num2 = len(summary) + 2
             altIndex =  altIndex + 1
             </%python>
%        #end for    
         </tbody>

         <%doc>
         ## Display the xtuple summary if and only if there is more than one
         ## alternative
         </%doc>

%        if len(tuple) > 1:
             <tbody id="<% shown_id %>">
%        else:
             <tbody id="<% hidden_id %>" class="hidden-rows" name="alt">
%        #end if
         <tr class="xtuple">
         <td class="nontuple"></td>
     
         <%doc>
         ##
         ## Display summary of attributes
         ##
         </%doc>
         <%python>
         count = 0
         </%python>
%        for val in summary:
             <%python>
             if count in c.results.u_columns:
                 for num in range(len(val)):
                    val[num] = '<span class="uncertain">' + val[num] + '</span>'
             else:
                 for num in range(len(val)):
                    val[num] = '<b>' + val[num] + '</b>'
             joinstr = """<span class="separator""" + str(c.results.type) + """"> || </span>"""
             if len(val) < 5:
               alts = joinstr.join(val)
             else:
               alts = joinstr.join(val[:4]) + (" <I>[%s more...]</I>" % (len(val)-4))
             </%python>
%            if count == 0:
                <td class="xtupleleft<% c.results.type %>" 
                onclick="toggle('<% hidden_id %>', '<% shown_id %>')"><% alts %></td>
%            else:
                <td class="xtuple<% c.results.type %>" 
                onclick="toggle('<% hidden_id %>', '<% shown_id %>')"><% alts %></td>
%            #end if
            <%python>
            count = count + 1
            </%python>
%        # end for

         <%doc>
         ##
         ## Display confidence/question mark if necessary. 
         ##
         </%doc>
         <td class="nontuple">
 
%        if c.results.type == TYPE_CONFIDENCE or c.results.type == TYPE_PROBABILISTIC:
%            if tuple.getConfidence() is not None:
                 <div class="conf-box<% c.results.type %>"><% "%.3f" % tuple.getConfidence() %></div>
%        else:
        <%python>
        indexurl = "index?query=%s&compconf=True&page_num=%s&xindex=%s" % \
            (c.query, str(c.results.getPage()), str(tupleIndex))
        </%python>
         <div class="conf-box<% c.results.type %>"><a href="<% indexurl %>">conf</a></div>
%            #end if
%        elif c.results.type == TYPE_UNCERTAIN:
%             if tuple.getQuestionMark():
                <div class="question-box">?</div>
%             #end if
%        #end if
        </td>
    </tr>
    </tbody>
    <tr><td colspan="<% num2 %>" class="blank" height="8px"></td></tr>
    <%python>
    tupleIndex = tupleIndex + 1
    </%python>
%    #end for    

</table>
</p>


### Print page navigation.
<p><% c.results.getPageNav() %></p>

% #end if (Outermost)
</div>


