__id__ = "$Id: dumper.py 526 2007-07-20 22:19:20Z theobald $"

from visitor import Visitor

class Dumper(Visitor):
    def __init__(self):
        self.level = 0
        self.indent = "   "

    def visit(self, node):
        nodetype = node.__class__.__name__
        visitfn = getattr(self, 'visit_'+nodetype, self.visit_default)
        visitfn(node)

    def visit_default(self, node):
        s = self.level * self.indent + node.__class__.__name__
        if node is not None:
            if node.value is not None:
                s += " " + str(node.value)
            print s
            self.level += 1
            for child in node.children:
                self.visit(child)
            self.level -= 1

